# Technical Manual

### Purpose (foobar)

This page summarizes program operation and command-line usage for ALE versions 0.8.0 through 0.8.4. Features specific to a particular version are annotated (e.g. [ALE 0.8.1 and later]).

Manual pages linked from this section describe default settings, file output, alignment, rendering, exclusion regions, control points, user interfaces, devices, and 3D scene reconstruction.

For more information on ALE, see the ALE Home Page.

### Parameter Meta-syntax

`<foo>` | A required parameter called foo.
`[<foo>]` | An optional parameter called foo.
`[<foo>]*` | Zero or more parameters foo.

### Command-line syntax for Image Processing

The following command-line invocation can be used to process a series of frames into an output file:

    ale [<option>]* <original-frame> [<supplemental-frame>]* <output-file>

### Option Arguments

Certain basic modes of operation, emphasizing image quality, speed, or other rendering characteristics, are now established in the form of default settings.

Other options are outlined in the manual pages describing file output, rendering, alignment, exclusion regions, devices, user interfaces, and 3D scene reconstruction.

### Image Files

ALE can be configured at compile time to use one of two different file handlers. Execute 'ale --version' to determine which file handler is being used. The table below outlines the supported formats for each file handler.

Version Message | File Types Supported
--- | ---

    File handler:     ImageMagick

Input and output files can be any of the formats supported by ImageMagick.

    File handler:     PPM

Input files must be PPM, and output files are written as PPM.

Note that many external programs, including ImageMagick's command line utilities, can be used to convert between PPM and other formats.

See the README included in the source distribution of ALE for more information about compile-time configuration of file handlers.

### Command-line syntax for Version Information

The following command-line invocation can be used to print version information and build options:

    ale --version

The following is sample output from this invocation:

    ALE Version:      0.8.4
    File handler:     ImageMagick
    Color data:       SINGLE
    Coordinate data:  SINGLE
    DFT:              FFTW3
    Assertions:       Enabled
    Optimizations:    Enabled

The first line of output indicates the version of ALE source code being used; the remaining lines reflect the build options selected at compile time.

For more information about build options, see the README file included in the ALE source distribution.

### Command-line syntax for Help Output

When invoked with no arguments, or an insufficient number of file arguments, ALE outputs a help message specifying command-line usage and available help topics. The following is a sample invocation:

    ale

### Help Topics

More information about specific help topics can be obtained with an invocation of the following form:

    ale <help option>

Available help options, and their corresponding help topics, are outlined below:

    --hu              Usage.
    --hq              Default settings.
    --hf              Image files.
    --he              Exclusion regions.
    --ha              Alignment (not exposure-related).
    --hr              Rendering (not exposure-related).
    --hx              Exposure.
    --ht              Transformation data files.
    --hc              Control points.  [0.8.1 and later]
    --hl              Filtering (PSFs, rendering chains).
    --hd              Devices.
    --hi              User Interfaces.
    --hv              Video stream processing (Experimental).
    --h3              3D Modeling.
    --hz              Undocumented options.
    --hA              Concatenate all help pages.

### Related Manual Pages

- Default Settings
- File Output
- Rendering
- Alignment
- Exclusion Regions
- Control Points (0.8.1 and later)
- Devices
- User Interfaces
- 3D Scene Reconstruction

Copyright 2003, 2004, 2005, 2006 David Hilvert

Verbatim copying and distribution of this entire article is permitted in any medium, provided this notice is preserved.